import { match_status } from '../../utils/dict';
const app = getApp()

Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '信息管理', leftArrow: true, useBar: false },
        list: [],
        searchInfo: {},
        dialog: { title: '赛事状态', show: false, type: '1' },
        form: {},
        statusList: match_status
    },
    // 跳转菜单
    back(e) {
        wx.navigateBack({ delta: 1 })
    },
    // 查询
    search: function (e) {
        const that = this;
        that.setData({ 'searchInfo.name': e.detail.value });
        that.watchLogin()
    },
    // 添加
    toAdd: function () {
        wx.navigateTo({ url: `/pages/match/matchadd` })
    },
    // 详情
    toView: function (e) {
        const { item } = e.currentTarget.dataset;
        wx.navigateTo({ url: `/pages/matchInfo/index?id=${item._id}` })
    },
    // 修改
    toEdit: function (e) {
        const { item } = e.currentTarget.dataset;
        wx.navigateTo({ url: `/pages/match/matchadd?id=${item._id}` })
    },
    // 删除
    toDel: async function (e) {
        const { item } = e.currentTarget.dataset;
        wx.showModal({
            title: '提示',
            content: '您确定要删除该条数据吗？',
            async success(res) {
                if (res.confirm) {
                    const arr = await app.$delete(`/newCourt/api/match/${item._id}`);
                    if (arr.errcode == '0') {
                        wx.showToast({ title: `删除信息成功`, icon: 'success', duration: 2000 });
                        that.watchLogin()
                    } else {
                        wx.showToast({ title: `${res.errMsg}`, icon: 'fail', duration: 2000 });
                    }
                }
            }
        })
    },
    // 赛事组别
    toGroup: function (e) {
        const { item } = e.currentTarget.dataset;
        wx.navigateTo({ url: `/pages/match/matchgroup?id=${item._id}` })
    },
    // 赛事状态
    toStatus: function (e) {
        const that = this;
        const { item } = e.currentTarget.dataset;
        that.setData({ form: item });
        that.setData({ dialog: { title: '赛事状态', show: true, type: '1' } });
    },
    // 选择状态
    statusChange: function (e) {
        const that = this;
        let data = that.data.statusList[e.detail.value];
        that.setData({ 'form.status': data.label })
        that.setData({ 'form.status_name': data.value })
    },
    // 提交
    onSubmit: async function (e) {
        const that = this;
        const arr = await app.$post(`/newCourt/api/match/${e.detail.value._id}`, e.detail.value)
        if (arr.errcode == '0') {
            wx.showToast({ title: `信息维护成功`, icon: 'success', duration: 2000 });
            that.watchLogin();
            that.toClose();
        } else { wx.showToast({ title: `${res.errMsg}`, icon: 'fail', duration: 2000 }); }
    },
    // 关闭弹框
    toClose: function () {
        const that = this;
        that.setData({ dialog: { title: '赛事状态', show: false, type: '1' } })
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;
        // 监听用户是否登录
        that.watchLogin();
    },
    watchLogin: function () {
        const that = this;
        let searchInfo = that.data.searchInfo;
        wx.getStorage({
            key: 'user',
            success: async (res) => {
                let info = { skip: 0, limit: 1000 };
                if (searchInfo && searchInfo.name) info.name = searchInfo.name;
                const arr = await app.$get(`/newCourt/api/match`, { ...info });
                if (arr.errcode == '0') {
                    that.setData({ list: arr.data })
                } else { wx.showToast({ title: `${res.errMsg}`, icon: 'fail', duration: 2000 }); }
            },
            fail: async (res) => {
                wx.redirectTo({ url: '/pages/index/index' });
            },
        });
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {
        const that = this;
        // 监听用户是否登录
        that.watchLogin();
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})